Attribute VB_Name = "Mod_2_GridControl"
Option Explicit
Dim rsVar As Variant
Dim intMaxColWidth() As Long
Dim intCnt1 As Integer
Dim intCnt2 As Integer

Public Sub subFormatGrid(ctlFlex As MSHFlexGrid)   'Called from subMenuGateWay in Mod_0_Main
   Call subFlexFixAndFill(ctlFlex)                 'In this module
   Call subPaintGrid(ctlFlex)                      'In this module
End Sub

'The following modual is a work-around to fix a
'bug in the MSHFlexGrid control, if you haven't
'already applied service pack 3 to handle this bug.
'The bug is: The flexgrid will only display 2048 records.
'Go to http://support.microsoft.com/support/kb/articles/Q194/6/53.ASP
'For more info, Aagain thanks to the guys at FreeVBCode for their help.
'If you have already applied service pack 3, you can just skip this
'procedure altogether.

Private Sub subFlexFixAndFill(ctlFlex As MSHFlexGrid)
   Dim lngCntr As Long
   ctlFlex.Clear
   ctlFlex.ColWidth(0) = 250
   ctlFlex.Rows = rcdset1.RecordCount + 1
   rsVar = rcdset1.GetString(adClipString, rcdset1.RecordCount)
   ctlFlex.Cols = rcdset1.Fields.Count + 1
   For lngCntr = 0 To rcdset1.Fields.Count - 1
      ctlFlex.TextMatrix(0, lngCntr + 1) = rcdset1.Fields(lngCntr).Name
   Next
   ctlFlex.Row = 1
   ctlFlex.Col = 1
   ctlFlex.RowSel = ctlFlex.Rows - 1
   ctlFlex.ColSel = ctlFlex.Cols - 1
   ctlFlex.Clip = rsVar
   ctlFlex.RowSel = ctlFlex.Row
   ctlFlex.ColSel = ctlFlex.Col
   rsVar = ""
   rcdset1.MoveFirst    'reset to the first record
End Sub
Private Sub subPaintGrid(ctlFlex As MSHFlexGrid)     'Paint every other row green, and set column widths
   If ctlFlex.Row > 0 Then
      GoSub subSetUpGrid
      GoSub subPaintGrid
      GoSub subSpreadColumns
      GoSub subResetGrid
   End If
   Exit Sub
subSetUpGrid:
   With ctlFlex
       ReDim intMaxColWidth(.Cols - 1)                '<--We'll need this arrayfor setting
      .Redraw = False                                 '   column widths.
      .Row = 0
      .RowSel = .Rows - 1
      .FillStyle = flexFillRepeat
      .Col = .FixedCols
      .Row = .FixedRows
      .RowSel = .Rows - 1
      .ColSel = .Cols - 1
      .CellBackColor = &HFFFFFF
   End With
subPaintGrid:                                          'Paint every other row light green
   With ctlFlex
      For intCnt1 = .FixedRows + 1 To .Rows - 1 Step 2
        .Row = intCnt1
        .Col = .FixedCols
        .ColSel = .Cols() - .FixedCols
        .CellBackColor = &HC0FFC0
      Next intCnt1
  End With
subSpreadColumns:                                        'Got your grid's font's set to Courier?
   With ctlFlex
      For intCnt1 = 0 To .Cols - 1                       'Prime the array with zero's
         intMaxColWidth(intCnt1) = 0                     'This helps you avoid those nasty little
      Next                                               'error messages.
      For intCnt1 = 0 To .Rows - 1                       'Gather the maximum text legnths
          .Row = intCnt1                                 'Looping through the columns alone won't cut it,
         For intCnt2 = 0 To .Cols - 1                    'loop trough each row and stow the greatest width
             .Col = intCnt2                              'for each column.
             If (Len(.Text) * 110) > intMaxColWidth(intCnt2) Then
                intMaxColWidth(intCnt2) = Len(.Text) * 110
             End If
         Next
      Next
      For intCnt2 = 1 To .Cols - 1                       'Set the column widths.
         .Col = intCnt2
         .ColWidth(intCnt2) = intMaxColWidth(intCnt2)
      Next
   End With
subResetGrid:                                            'Put things back the way
   With ctlFlex                                          'you found them.
      .FillStyle = flexFillSingle
      .Redraw = True
      .Row = 1: .Col = 1
   End With
End Sub

