Attribute VB_Name = "Mod_3_PrinterControl"
Option Explicit
Dim lngPaperSize As Long
Dim lngOrientation As Long
Dim intMaxRowPerPage As Integer
Dim intCnter1 As Long
Dim intCnter2 As Long
Dim intCnter3 As Long
Dim intCnter4 As Long
Dim intRowCnt As Integer
Dim intPgeCnt As Integer
Dim intRowStart As Integer
Dim intColStart As Integer
Dim intRowEnd As Integer
Dim intColEnd As Integer
Dim intBeginCol() As Integer
Dim intEndCol() As Integer
Dim intIncY As Integer
Dim intIncX As Integer
Dim sngTotWidth As Single
Dim intMaxPgSize As Integer
Dim sngTotPageWidth As Single
Dim bolOKtoPrint As Boolean

Public Sub subPrintGrids(intx As Integer)          'Called from subMenuGateWay in Mod_0_Main
   Call subSetUpPrinter(intx)                      'In this module.
   Call subCheckWidth(mFrm.MSHFlexGrid1)           'In this module.
   If bolOKtoPrint = True Then
      Call PrintSelected(mFrm.MSHFlexGrid1)        'In this module.
      Call subPrintIt                              'In this module.
   End If
End Sub
Private Sub subSetUpPrinter(intx As Integer)
   'Set up the printer according to the user selection
   Select Case intx
      Case 1: lngPaperSize = vbPRPSLetter: lngOrientation = vbPRORPortrait:  intMaxRowPerPage = 100
      Case 2: lngPaperSize = vbPRPSLetter: lngOrientation = vbPRORLandscape: intMaxRowPerPage = 73
      Case 3: lngPaperSize = vbPRPSLegal:  lngOrientation = vbPRORPortrait:  intMaxRowPerPage = 126
      Case 4: lngPaperSize = vbPRPSLegal:  lngOrientation = vbPRORLandscape: intMaxRowPerPage = 73
      Case 5: lngPaperSize = vbPRPS11x17:  lngOrientation = vbPRORPortrait:  intMaxRowPerPage = 153
      Case 6: lngPaperSize = vbPRPS11x17:  lngOrientation = vbPRORLandscape: intMaxRowPerPage = 100
   End Select
   Printer.ScaleMode = 1
   Printer.CurrentX = 10
   Printer.CurrentY = 10
   Printer.Font = "Courier New"
   Printer.PaperSize = lngPaperSize
   Printer.Orientation = lngOrientation
End Sub
Private Sub subCheckWidth(ctlFlex As MSHFlexGrid)
   'Lets make sure the user got his selection right
   GoSub subHoldSelectionParameters
   GoSub subAddCellWidths
   GoSub subResetSelectionParameters
   GoSub subDecideToPrint
   Exit Sub
subHoldSelectionParameters:               'Move the grids parameters into varibles
   sngTotWidth = 0
   ctlFlex.Redraw = False                 'turn the redraw off or its gonna reek havoc
   intColStart = ctlFlex.Col
   intColEnd = ctlFlex.ColSel
   intRowStart = ctlFlex.Row
   intRowEnd = ctlFlex.RowSel
   Return
subAddCellWidths:                         'loop through and add up column widths
   For intCnter1 = intColStart To intColEnd
       ctlFlex.Col = intCnter1
       If (sngTotWidth + ctlFlex.CellWidth) > Printer.Width Then   'Will it fit?
          bolOKtoPrint = False
       Else
          bolOKtoPrint = True
       End If
       sngTotWidth = sngTotWidth + ctlFlex.CellWidth
   Next
   Return
subResetSelectionParameters:              'Note, Looping through that grid kills your
   ctlFlex.Row = intRowStart              'selection parameters. So you need to reset
   ctlFlex.Col = intColStart              'them here with the varibles that you stored
   ctlFlex.RowSel = intRowEnd             'them in. Also, make sure you set .Row and .col
   ctlFlex.ColSel = intColEnd             'before .rowSel and ColSel to get your selection back.
   ctlFlex.Redraw = True
   Return
subDecideToPrint:                           'This gives the user the option of cancelling the job,
  If bolOKtoPrint = False Then              'or allowing the program to size-up the print job.
      If MsgBox("Selected Area Is Greater Than Page Selection." & vbCrLf _
         & "Use next larger size?", vbYesNo, "A.D.S.") = vbYes Then
         GoSub subFindSizeThatFits
      Else
         MsgBox "Cancelling Print Job"
      End If
  Else
   '  MsgBox here if you want one.
  End If
  Return
subFindSizeThatFits:                         'Find the next size, and call up
   bolOKtoPrint = True                       'subSetUpPrinter to reset the printer
   Select Case sngTotWidth
      Case 12240 To 15840
           Call subSetUpPrinter(2)
      Case 15841 To 20160
           MsgBox "Load printer with legal size paper."
           Call subSetUpPrinter(4)
      Case Is > 20161
           MsgBox "Load printer with size 11 x 17 size paper."
           Call subSetUpPrinter(6)
   End Select
End Sub
Private Sub PrintSelected(ctlFlex As MSHFlexGrid)
   GoSub subSetParameters
   GoSub subGetPageWidths
   GoSub subResetSelectionParameters
   GoSub SubRunIt
   ctlFlex.Redraw = True
   Exit Sub
subSetParameters:             'These two arrays are used to define columns per page.
   ReDim intBeginCol(0)       'You can use one two-dimentional array if you want,
   ReDim intEndCol(0)         'this is just a little easier to understand.
   intMaxPgSize = 23040       '23040 = 16 inches of print area, 11x17 landscape
   intRowStart = ctlFlex.Row
   intColStart = ctlFlex.Col   'Again store your parameters, and set your working varibles.
   intRowEnd = ctlFlex.RowSel
   intColEnd = ctlFlex.ColSel
   sngTotPageWidth = 0
   intCnter1 = 0
   intCnter2 = 0
   intCnter3 = 0
   intRowCnt = 0
   intPgeCnt = 0
   intIncX = 150
   intIncY = 150
   ctlFlex.Redraw = False      'eliminates flicker
   Return
subGetPageWidths:                            'This sub loops through the columns and finds the last column
   For intCnter1 = intColStart To intColEnd  'that will fit on a page, parks the begining and ending columns
       ctlFlex.Col = intCnter1               'in an array, building the array to mark begining and ending columns
       If sngTotPageWidth = 0 Then           'for lateral pages.
          intCnter2 = intCnter2 + 1
          ReDim Preserve intBeginCol(intCnter2): intBeginCol(intCnter2) = intCnter1
       End If
       If (sngTotPageWidth + ctlFlex.CellWidth) > intMaxPgSize Then
          intCnter3 = intCnter3 + 1
          ReDim Preserve intEndCol(intCnter3): intEndCol(intCnter3) = intCnter1
          sngTotPageWidth = 0
       Else
          sngTotPageWidth = sngTotPageWidth + ctlFlex.CellWidth
       End If
       If intCnter1 = intColEnd Then          'be sure to get the last column
          intCnter3 = intCnter3 + 1
          ReDim Preserve intEndCol(intCnter3): intEndCol(intCnter3) = intCnter1
       End If
   Next
   Return
subResetSelectionParameters:      'We've been through this
   ctlFlex.Row = intRowStart:  ctlFlex.Col = intColStart
   ctlFlex.RowSel = intRowEnd: ctlFlex.ColSel = intColEnd
   Return
SubRunIt:                                     'Ok, Here's where it gets tricky.
   For intCnter1 = 1 To UBound(intBeginCol)   'The upper bound of that column array
     intPgeCnt = 0: intRowCnt = 0             'will be your number of lateral pages.
     GoSub subHeader              'Print the first header.
     GoSub subBody                'Your main loop.
     Printer.NewPage              'Crank out a new one.
     intIncX = 150: intIncY = 150 'Be sure to reset your co-ordinates.
   Next
   Return
subHeader:
   'Get Column Headers
   ctlFlex.Row = 0
   intPgeCnt = intPgeCnt + 1
   Printer.CurrentX = intIncX
   Printer.Print "Page # " & intPgeCnt & "-" & Chr(64 + intCnter1)  'Ex., Page # 1-A
   For intCnter2 = intBeginCol(intCnter1) To intEndCol(intCnter1)   'intCnter2 counts throught the set of
      ctlFlex.Col = intCnter2                                       'columns in your arrays for the header sub.
      GoSub subMakePrintRow
   Next
   Printer.Line (intIncX, intIncY)-(intIncX, intIncY + 150)         'Last Vertical line in header.
   intRowCnt = intRowCnt + 2
   Return
subBody:
   For intCnter3 = intRowStart To intRowEnd                         'intCnter3 counts your total rows
      intRowCnt = intRowCnt + 1                                     'intRowCnt counts your rows per page
      If intRowCnt = intMaxRowPerPage Then                          'Has the page filled up yet?
         Printer.Line (150, intIncY + 150)-(intIncX, intIncY + 150) 'Last horizontal line on page.
         Printer.NewPage                                            'Time For a new page.
         intIncX = 150
         intIncY = 150
         intRowCnt = 0
         GoSub subHeader                                            'You want a header on each page don't you?
      End If
      ctlFlex.Row = intCnter3
      intIncY = intIncY + 150
      intIncX = 150
      For intCnter4 = intBeginCol(intCnter1) To intEndCol(intCnter1)   'intCnter4 counts throught the set of
         ctlFlex.Col = intCnter4                                       'columns in your arrays for the body sub.
         GoSub subMakePrintRow
      Next
      Printer.Line (intIncX, intIncY)-(intIncX, intIncY + 150)                   'Last vertical line on printed row
   Next
   Printer.Line (150, intIncY + 150)-(intIncX, intIncY + 150)                    'Last horizontal on printed row
   GoSub subFooter
   Return
subFooter:
   Printer.CurrentX = 150                             'Beef up the footer with cool stuff if you want to,
   Printer.Print intRowEnd & " rows printed."         'just remember to adjust your co-ordinates for each line.
   Return
subMakePrintRow:                                      'The meat of the procedure
   Printer.CurrentX = intIncX                         'You need to adjust your co-ordinates with each row.
   Printer.CurrentY = intIncY
   Printer.Print ctlFlex.Text                         'Print the current cell, and increment your co-ordinates
   Printer.Line (intIncX, intIncY)-(intIncX, intIncY + 150)                'Vertical
   Printer.Line (intIncX, intIncY)-(intIncX + ctlFlex.CellWidth, intIncY)  'Horizontal
   intIncX = intIncX + ctlFlex.CellWidth
   Return
End Sub
Private Sub subPrintIt()   'Print it!
   Printer.EndDoc
End Sub
'Hope this helps!
